unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls,

  {!} UTTFToVector, ComCtrls, StdCtrls {!};

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    FontBtn: TSpeedButton;
    Panel2: TPanel;
    ColorBtn: TSpeedButton;
    PrevCharBtn: TSpeedButton;
    TheChar: TSpeedButton;
    NextCharBtn: TSpeedButton;
    AutoBtn: TSpeedButton;
    QuitBtn: TSpeedButton;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    Timer: TTimer;
    StatusBar1: TStatusBar;
    PaintBox: TPaintBox;
    Label1: TLabel;
    PrecisionBar: TScrollBar;
    PrecisionValue: TLabel;
    procedure FontBtnClick(Sender: TObject);
    procedure ColorBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PrevCharBtnClick(Sender: TObject);
    procedure NextCharBtnClick(Sender: TObject);
    procedure AutoBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure TheCharClick(Sender: TObject);
    procedure QuitBtnClick(Sender: TObject);
    procedure PrecisionBarChange(Sender: TObject);
  private
    FChar: char;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FChar := 'A';
  TheChar.Caption := FChar;
end;

procedure TMainForm.FontBtnClick(Sender: TObject);
begin
  try
    if FontDialog.Execute then
    begin
      FontDialog.Font.Size := 28;
      TheChar.Font := FontDialog.Font;
      PaintBox.Invalidate;
    end;
  except
  end;
end;

procedure TMainForm.ColorBtnClick(Sender: TObject);
begin
  try
    if ColorDialog.Execute then
      PaintBox.Invalidate;
  except
  end;
end;

procedure TMainForm.PrevCharBtnClick(Sender: TObject);
begin
  if FChar = #32 then
    FChar := #255
  else
    FChar := pred( FChar );
  TheChar.Caption := FChar;
  PaintBox.Invalidate;
end;

procedure TMainForm.NextCharBtnClick(Sender: TObject);
begin
  if FChar = #255 then
    FChar := #32
  else
    FChar := succ( FChar );
  TheChar.Caption := FChar;
  PaintBox.Invalidate;
end;

procedure TMainForm.AutoBtnClick(Sender: TObject);
begin
  Timer.Enabled := AutoBtn.Down;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
  NextCharBtnClick( nil );
end;

procedure TMainForm.PaintBoxPaint(Sender: TObject);
var converter: TTTFToVectorConverter;
    glyphs: TStrokeCollection;
    cbounds: TRect;
    sx, sy: double; // Scaling factors
    stroke: TFontStroke;
    x1, y1,
    x2, y2: integer;
    i: integer;
begin
  // Create the converter
  converter := TTTFToVectorConverter.Create;
  // Setup font
  converter.Font := FontDialog.Font;
  // Setup spline precision (1 min, 100 max)
  converter.Precision := PrecisionBar.Position;
  // Get glyphs' strokes
  glyphs := converter.GetCharacterGlyphs( ord(FChar) );
  // Free the converter
  converter.Free;
  // Get character bounds
  cbounds := glyphs.Bounds;
  // Compute the scaling factors
  sx := (PaintBox.Width-20)/(cbounds.Right-cbounds.Left+1);
  sy := (PaintBox.Height-20)/(cbounds.Bottom-cbounds.Top+1);
  // Draw!
  PaintBox.Canvas.Pen.Color := ColorDialog.Color;
  for i := 0 to glyphs.Count-1 do
  begin
    // Get a stroke
    stroke := glyphs.Stroke[i];
    // Scale it down or up
    x1 := 10 + round( (stroke.Pt1.X-cbounds.Left) * sx );
    y1 := 10 + round( (stroke.Pt1.Y-cbounds.Top) * sy );
    x2 := 10 + round( (stroke.Pt2.X-cbounds.Left) * sx );
    y2 := 10 + round( (stroke.Pt2.Y-cbounds.Top) * sy );
    // Draw the stroke
    PaintBox.Canvas.MoveTo( x1, PaintBox.Height-y1-1 );
    PaintBox.Canvas.LineTo( x2, PaintBox.Height-y2-1 );
  end;
  // Free the glyphs
  glyphs.Free;
end;

procedure TMainForm.TheCharClick(Sender: TObject);
begin
  FChar := 'A';
  PaintBox.Invalidate;
end;

procedure TMainForm.QuitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.PrecisionBarChange(Sender: TObject);
begin
  PrecisionValue.Caption := IntToStr( PrecisionBar.Position );
  PaintBox.Invalidate;
end;

end.
